# Class DefaultGeographicCRS

Object
FormattableObject
AbstractIdentifiedObject
AbstractReferenceSystem
AbstractCRS
DefaultGeographicCRS

All Implemented Interfaces:
  `Serializable, Formattable, Deprecable, LenientComparable, Printable, CoordinateReferenceSystem, GeodeticCRS, GeographicCRS, SingleCRS, IdentifiedObject, ReferenceSystem`

public class DefaultGeographicCRS extends AbstractCRS implements GeographicCRS
A 2- or 3-dimensional coordinate reference system based on an ellipsoidal approximation of the geoid. This provides an accurate representation of the geometry of geographic features for a large portion of the earth's surface.

Used with datum type: Geodetic.
Used with coordinate system type: Ellipsoidal.

## Creating new geographic CRS instances

New instances can be created either directly by specifying all information to a factory method (choices 3 and 4 below), or indirectly by specifying the identifier of an entry in a database (choices 1 and 2 below). Choice 1 in the following list is the easiest but most restrictive way to get a geographic CRS. The other choices provide more freedom.

1. Create a `GeographicCRS` from one of the static convenience shortcuts listed in `CommonCRS​.geographic()` or `CommonCRS​.geographic3D()`.
2. Create a `GeographicCRS` from an identifier in a database by invoking `GeodeticAuthorityFactory​.createGeographicCRS(String)`.
3. Create a `GeographicCRS` by invoking the `CRSFactory​.createGeographicCRS(…)` method (implemented for example by `GeodeticObjectFactory`).
4. Create a `GeographicCRS` by invoking the
   invalid reference

       constructor

   .

Example: the following code gets a two-dimensional geographic CRS using the World Geodetic System 1984 datum:

    GeodeticDatum datum = CommonCRS.WGS84.geographic();

## Immutability and thread safety

This class is immutable and thus thread-safe if the property values (not necessarily the map itself), the coordinate system and the datum instances given to the constructor are also immutable. Unless otherwise noted in the javadoc, this condition holds if all components were created using only SIS factories and static constants.

Since:
  0.4
See Also:
  - `GeodeticAuthorityFactory​.createGeographicCRS(String)`
  - Serialized Form

- ## Field Summary

  ### Fields inherited from class AbstractIdentifiedObject

  `DEPRECATED_KEY, DOMAINS_KEY, LOCALE_KEY`

  ### Fields inherited from interface IdentifiedObject

  `ALIAS_KEY, IDENTIFIERS_KEY, NAME_KEY, REMARKS_KEY`

  ### Fields inherited from interface ReferenceSystem

  `DOMAIN_OF_VALIDITY_KEY, SCOPE_KEY`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  ``
  `DefaultGeographicCRS(Map<String,?> properties, GeodeticDatum datum, DefaultDatumEnsemble<GeodeticDatum> ensemble, EllipsoidalCS cs)`
  Creates a coordinate reference system from the given properties, datum and coordinate system.
  `protected`
  `DefaultGeographicCRS(GeographicCRS crs)`
  Constructs a new coordinate reference system with the same values as the specified one.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultGeographicCRS`
  `castOrCopy(GeographicCRS object)`
  Returns a SIS coordinate reference system implementation with the same values as the given arbitrary implementation.
  `DefaultGeographicCRS`
  `forConvention(AxesConvention convention)`
  Returns a CRS equivalent to this one but with axes rearranged according the given convention.
  `protected String`
  `formatTo(Formatter formatter)`
  Formats this CRS as a Well Known Text `GeographicCRS[…]` element.
  `EllipsoidalCS`
  `getCoordinateSystem()`
  Returns the coordinate system.
  `final GeodeticDatum`
  `getDatum()`
  Returns the geodetic reference frame associated to this geographic CRS.
  `DefaultDatumEnsemble<GeodeticDatum>`
  `getDatumEnsemble()`
  Returns a collection of datums which, for low accuracy requirements, may be considered to be insignificantly different from each other.
  `Ellipsoid`
  `getEllipsoid()`
  Returns the ellipsoid which is indirectly (through a datum) associated to this CRS.
  `Class<? extends GeographicCRS>`
  `getInterface()`
  Returns the GeoAPI interface implemented by this class.
  `PrimeMeridian`
  `getPrimeMeridian()`
  Returns the prime meridian which is indirectly (through a datum) associated to this CRS.

  ### Methods inherited from class AbstractCRS

  `castOrCopy`

  ### Methods inherited from class AbstractReferenceSystem

  `getDomainOfValidity, getScope`

  ### Methods inherited from class AbstractIdentifiedObject

  `castOrCopy, equals, formatTo, getAlias, getDescription, getDomains, getIdentifiers, getName, getRemarks, hashCode, isDeprecated, isHeuristicMatchForName`

  ### Methods inherited from class FormattableObject

  `print, toString, toString, toWKT`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface IdentifiedObject

  `getAlias, getIdentifiers, getName, getRemarks, toWKT`

  ### Methods inherited from interface ReferenceSystem

  `getDomainOfValidity, getScope`

- ## Constructor Details

  - ### DefaultGeographicCRS

    public DefaultGeographicCRS(Map<String,?> properties, GeodeticDatum datum, DefaultDatumEnsemble<GeodeticDatum> ensemble, EllipsoidalCS cs)
    Creates a coordinate reference system from the given properties, datum and coordinate system. At least one of the `datum` and `ensemble` arguments shall be non-null. The properties given in argument follow the same rules as for the super-class constructor. The following table is a reminder of main (not all) properties:

    Recognized properties (non exhaustive list)
    Property name | Value type | Returned by
    --- | --- | ---
    "name" | `ReferenceIdentifier` or `String` | `AbstractIdentifiedObject.getName()`
    "alias" | `GenericName` or `CharSequence` (optionally as array) | `AbstractIdentifiedObject.getAlias()`
    "identifiers" | `ReferenceIdentifier` (optionally as array) | `AbstractIdentifiedObject.getIdentifiers()`
    "domains" | `DefaultObjectDomain` (optionally as array) | `AbstractIdentifiedObject.getDomains()`
    "remarks" | `InternationalString` or `String` | `AbstractIdentifiedObject.getRemarks()`

    Parameters:
      `properties` - the properties to be given to the coordinate reference system.
      `datum` - the datum, or `null` if the CRS is associated only to a datum ensemble.
      `ensemble` - collection of reference frames which for low accuracy requirements may be considered to be insignificantly different from each other, or `null` if there is no such ensemble.
      `cs` - the two- or three-dimensional coordinate system.
    Since:
      1.5
    See Also:
      - `GeodeticObjectFactory​.createGeographicCRS(Map, GeodeticDatum, DefaultDatumEnsemble, EllipsoidalCS)`

  - ### DefaultGeographicCRS

    protected DefaultGeographicCRS(GeographicCRS crs)
    Constructs a new coordinate reference system with the same values as the specified one. This copy constructor provides a way to convert an arbitrary implementation into a SIS one or a user-defined one (as a subclass), usually in order to leverage some implementation-specific API.

    This constructor performs a shallow copy, i.e. the properties are not cloned.

    Parameters:
      `crs` - the coordinate reference system to copy.
    See Also:
      - `castOrCopy(GeographicCRS)`

- ## Method Details

  - ### castOrCopy

    public static DefaultGeographicCRS castOrCopy(GeographicCRS object)
    Returns a SIS coordinate reference system implementation with the same values as the given arbitrary implementation. If the given object is `null`, then this method returns `null`. Otherwise if the given object is already a SIS implementation, then the given object is returned unchanged. Otherwise a new SIS implementation is created and initialized to the attribute values of the given object.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getInterface

    public Class<? extends GeographicCRS> getInterface()
    Returns the GeoAPI interface implemented by this class. The SIS implementation returns `GeographicCRS​.class`.

    #### Note for implementers

    Subclasses usually do not need to override this method since GeoAPI does not define `GeographicCRS` sub-interface. Overriding possibility is left mostly for implementers who wish to extend GeoAPI with their own set of interfaces.
    Returns:
      `GeographicCRS​.class` or a user-defined sub-interface.

  - ### getPrimeMeridian

    public PrimeMeridian getPrimeMeridian()
    Returns the prime meridian which is indirectly (through a datum) associated to this CRS. If the datum is non-null, then this method returns the datum prime meridian. Otherwise, if all members of the datum ensemble use the same prime meridian, then this method returns that meridian.
    Returns:
      the prime meridian indirectly associated to this CRS.
    Throws:
      `NoSuchElementException` - if there is no datum and the ensemble does not contain at least one member.
      `GeodeticException` - if the prime meridian is not the same for all members of the datum ensemble.
    Since:
      1.5

  - ### getEllipsoid

    public Ellipsoid getEllipsoid()
    Returns the ellipsoid which is indirectly (through a datum) associated to this CRS. If the datum is non-null, then this method returns the datum ellipsoid. Otherwise, if all members of the datum ensemble use the same ellipsoid, then this method returns that ellipsoid.
    Returns:
      the ellipsoid indirectly associated to this CRS.
    Throws:
      `NoSuchElementException` - if there is no datum and the ensemble does not contain at least one member.
      `GeodeticException` - if the ellipsoid is not the same for all members of the datum ensemble.
    Since:
      1.5

  - ### getDatum

    public final GeodeticDatum getDatum()
    Returns the geodetic reference frame associated to this geographic CRS. This property may be null if this CRS is related to an object identified only by a datum ensemble.
    Specified by:
      `getDatum` in interface `GeodeticCRS`
    Specified by:
      `getDatum` in interface `SingleCRS`
    Returns:
      the geodetic reference frame, or `null` if this CRS is related to an object identified only by a datum ensemble.

  - ### getDatumEnsemble

    public DefaultDatumEnsemble<GeodeticDatum> getDatumEnsemble()
    Returns a collection of datums which, for low accuracy requirements, may be considered to be insignificantly different from each other. This property may be null if this CRS is related to an object identified only by a single datum.
    Warning: in a future SIS version, the return type may be changed to the `org​.opengis​.referencing​.datum​.DatumEnsemble` interface. This change is pending GeoAPI revision.
    Returns:
      the datum ensemble, or `null` if this CRS is related to an object identified only by a single datum.
    Since:
      1.5

  - ### getCoordinateSystem

    public EllipsoidalCS getCoordinateSystem()
    Returns the coordinate system.
    Specified by:
      `getCoordinateSystem` in interface `CoordinateReferenceSystem`
    Specified by:
      `getCoordinateSystem` in interface `GeographicCRS`
    Specified by:
      `getCoordinateSystem` in interface `SingleCRS`
    Overrides:
      `getCoordinateSystem` in class `AbstractCRS`
    Returns:
      the coordinate system.

  - ### forConvention

    public DefaultGeographicCRS forConvention(AxesConvention convention)
    Returns a CRS equivalent to this one but with axes rearranged according the given convention. If this CRS is already compatible with the given convention, then this method returns `this`.
    Overrides:
      `forConvention` in class `AbstractCRS`
    Parameters:
      `convention` - the axes convention for which a coordinate reference system is desired.
    Returns:
      a coordinate reference system compatible with the given convention (may be `this`).
    See Also:
      - `AbstractCS​.forConvention(AxesConvention)`

  - ### formatTo

    protected String formatTo(Formatter formatter)
    Formats this CRS as a Well Known Text `GeographicCRS[…]` element.

    #### Example

    Well-Known Text (version 2) of a geographic coordinate reference system using the WGS 84 datum.

        GeographicCRS["WGS 84",
           Datum["World Geodetic System 1984",
             Ellipsoid["WGS84", 6378137.0, 298.257223563, LengthUnit["metre", 1]]],
             PrimeMeridian["Greenwich", 0.0, AngleUnit["degree", 0.017453292519943295]],
           CS["ellipsoidal", 2],
             Axis["Latitude", north],
             Axis["Longitude", east],
             AngleUnit["degree", 0.017453292519943295],
           Area["World"],
           BBox[-90.00, -180.00, 90.00, 180.00],
           Scope["Used by GPS satellite navigation system."],
           Id["EPSG", 4326, Citation["IOGP"], URI["urn:ogc:def:crs:EPSG::4326"]]]

    Same coordinate reference system using WKT 1.

        GEOGCS["WGS 84",
           DATUM["World Geodetic System 1984",
             SPHEROID["WGS84", 6378137.0, 298.257223563]],
             PRIMEM["Greenwich", 0.0],
           UNIT["degree", 0.017453292519943295],
           AXIS["Latitude", NORTH],
           AXIS["Longitude", EAST],
           AUTHORITY["EPSG", "4326"]]

    Parameters:
      `formatter` - the formatter where to format the inner content of this WKT element.
    Returns:
      `"GeodeticCRS"` (WKT 2) or `"GeogCS"` (WKT 1).
    See Also:
      - `FormattableObject​.toWKT()`
      - `FormattableObject​.toString()`